delete from report_sql where computer={?computer};

insert into report_sql (computer, num1, num2, num3, num4, num5, str1, str2, str3, str4, str5, str6, str7, str8, date1)
select {?computer}, a.id, b.id, b.znesek, a.id_saldkont, b.znesek, b.id_tip_trans, b.id_cards, e.opis, d.opis, b.nvaluta, 
a.n_racuna, k.priimek, p.ime, a.datum 
from (((((exchange a inner join money b on a.id=b.id_menjave) 
inner join saldkont c on a.id_saldkont=c.id_saldkont) 
inner join nncards d on b.id_cards=d.id_cards) 
inner join tipi_trans e on b.id_tip_trans=e.id_tip_trans) 
inner join kupci k on c.id_kupca=k.id) left outer join plovila p on c.id_plovila=p.id
where (a.datum>={?datum_od} and a.datum<={?datum_do}) 
and (a.storno is null or a.storno='')
order by b.id_tip_trans, b.id_cards, b.id_money;

insert into report_sql (computer, num3, num5, str1, str7) values ({?computer}, 200, 200, 'INK', 'DEPOSIT');

insert into report_sql (computer, num1, num3, num5, str1, str6, str7, str8, str9, date1)
select {?computer}, a.id_saldkont, b.znesek, a.znesek, a.vrsta_racuna, a.n_racuna, k.priimek, p.ime, c.n_racuna, a.datum
from (((saldkont a left outer join saldkont_zap b on a.id_saldkont=b.id_pl_saldkont) 
left outer join saldkont c on b.id_saldkont=c.id_saldkont) 
left outer join kupci k on c.id_kupca=k.id) left outer join plovila p on c.id_plovila=p.id
where (a.datum>={?datum_od} and a.datum<={?datum_do}) and a.vrsta_racuna in ('AKF','VIR','ONL') 
and (a.storno is null or a.storno='')
order by a.id_saldkont;

insert into report_sql (computer, num1, num3, num5, str1, str6, str7, str9, date1)
select {?computer}, a.id_saldkont, a.za_placilo, a.za_placilo, a.vrsta_racuna, a.n_racuna, k.priimek, 'Storno', a.datum
from saldkont a, kupci k where a.datum>={?datum_od} and a.datum<={?datum_do}
and a.vrsta_racuna in ('AKF','VIR','ONL') and a.id_kupca=k.id and storno is not null
order by a.id_saldkont;