select plovila.ime as "Boat", plovila.trenutni_objekt_priveza as "Temporary location", plovila.trenutna_n_priveza as "Temporary berth", 
rezervac.datum_rezervacije as "From", rezervac.datum_do as "To",
m_pogodbe.objekt as "Contract location", m_pogodbe.n_priveza as "Contract berth", 
m_pogodbe.datum_zacetka as "Contract from", m_pogodbe.datum_konca as "Contract to"
from rezervac
left outer join plovila on (rezervac.id_plovila = plovila.id)
left outer join m_pogodbe on (m_pogodbe.id_plovila = plovila.id and m_pogodbe.status in ('A', 'O'))
where rezervac.id_plovila = plovila.id and
rezervac.status_rezervac=1 and rezervac.datum_do < sysdate;