delete from report_sql where computer={?computer};

--drzava (str1) in st. drzav (num1)
insert into report_sql (computer, str1, str2, str3, num1, date1, date2)
select {?computer}, sifra, opis, oznaka, count(*), {?datum_od}, {?datum_do} from nndrzave
where 1=1 group by sifra, opis, oznaka;


-- privezi na voljo
update report_sql set
num2=(select count(*) from nnprivez where 1=1 
?and objekt = {?objekt}
)
where computer={?computer};

--noitve na voljo (num4)
update report_sql set
num4=({?datum_do}-{?datum_od})*num2
where computer={?computer};


--noitve zasedene zastava (num5)
update report_sql set
num5=nvl((select st_zased_dni_sum from
          (select sum(st_zased_dni) as st_zased_dni_sum, nzastava from (
             select 
                 case when r.datum_od = r.datum_do then 1 
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 p.nzastava as nzastava
             from rezervac_detail r, plovila p, rezervac rz, nnprivez z
	     where r.id_rezervac=rz.id and rz.id_plovila=p.id and r.id_privez=z.id_privez
             and r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
             ?and z.objekt = {?objekt} 
             )
            group by nzastava)
     where nzastava=str1),0)
where computer={?computer};


--noitve zasedene dravljanstvo (num6)
update report_sql set
num6=nvl((select st_zased_dni_sum from
          (select sum(st_zased_dni) as st_zased_dni_sum, ndrzava from (
             select 
                 case when r.datum_od = r.datum_do then 1 
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 k.ndrzava as ndrzava
             from rezervac_detail r, kupci k, rezervac rz, nnprivez n
	     where r.id_rezervac=rz.id and rz.id_lastnika=k.id and r.id_privez=n.id_privez 
             and r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
             ?and n.objekt = {?objekt} 
             )
            group by ndrzava)
     where ndrzava=str1),0)
where computer={?computer};

--noitve na voljo za celo leto(num11)
update report_sql set
num11=({?datum_do}-TRUNC({?datum_od},'YEAR'))*num2
where computer={?computer};

--noitve zasedene dravljanstvo za celo leto(num12)
update report_sql set
num12=nvl((select st_zased_dni_sum from
          (select sum(st_zased_dni) as st_zased_dni_sum, ndrzava from (
             select 
                 case when r.datum_od = r.datum_do then 1 
                 when r.datum_od < TRUNC({?datum_od},'YEAR') then 
                     case when r.datum_do < {?datum_do} then r.datum_do - TRUNC({?datum_od},'YEAR')
                                                        else {?datum_do} - TRUNC({?datum_od},'YEAR')
                     end
                 when r.datum_od >= TRUNC({?datum_od},'YEAR') then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 k.ndrzava as ndrzava
             from rezervac_detail r, kupci k, rezervac rz, nnprivez n
	     where r.id_rezervac=rz.id and rz.id_lastnika=k.id and r.id_privez=n.id_privez 
             and r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > TRUNC({?datum_od},'YEAR') or
                  r.datum_od = r.datum_do and r.datum_od = TRUNC({?datum_od},'YEAR'))
             ?and n.objekt = {?objekt} 
             )
            group by ndrzava)
     where ndrzava=str1),0)
where computer={?computer};

--noitve zasedene - booking (num13)
update report_sql set
num13=nvl((select st_zased_dni_sum from
          (select sum(st_zased_dni) as st_zased_dni_sum, nzastava from (
             select 
                 case when r.datum_od = r.datum_do then 1 
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 p.nzastava as nzastava
             from rezervac_detail r, plovila p, rezervac rz, nnprivez z
	     where r.id_rezervac=rz.id and rz.id_plovila=p.id and r.id_privez=z.id_privez
             and r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
	     and p.booking='B'
             ?and z.objekt = {?objekt} 
             )
            group by nzastava)
     where nzastava=str1),0)
where computer={?computer};


--noitve zasedene - ni booking (num14)
update report_sql set
num14=nvl((select st_zased_dni_sum from
          (select sum(st_zased_dni) as st_zased_dni_sum, nzastava from (
             select 
                 case when r.datum_od = r.datum_do then 1 
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 p.nzastava as nzastava
             from rezervac_detail r, plovila p, rezervac rz, nnprivez z
	     where r.id_rezervac=rz.id and rz.id_plovila=p.id and r.id_privez=z.id_privez
             and r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
	     and p.booking is null
             ?and z.objekt = {?objekt} 
             )
            group by nzastava)
     where nzastava=str1),0)
where computer={?computer};



-- stevilo pogodb na zadnji izbrani dan obdobja, neprekinjene pogodbe- short term
update report_sql set 
num7=(
select count (a.id_pogodbe) 
from m_pogodbe a where a.datum_prekinitve is null and
a.datum_zacetka<={?datum_do}-1 and a.datum_konca>={?datum_do}-1 and a.datum_konca-a.datum_zacetka<=31
?and a.objekt={?objekt}
)
where computer={?computer};



-- stevilo pogodb na zadnji izbrani dan obdobja, neprekinjene pogodbe- mid term
update report_sql set 
num15=(
select count (a.id_pogodbe) 
from m_pogodbe a where a.datum_prekinitve is null and
a.datum_zacetka<={?datum_do}-1 and a.datum_konca>={?datum_do}-1 and a.datum_konca-a.datum_zacetka>31 and a.datum_konca-a.datum_zacetka<364
?and a.objekt={?objekt}
)
where computer={?computer};


-- stevilo pogodb na zadnji izbrani dan obdobja, neprekinjene pogodbe - long term
update report_sql set 
num8=(
select count (a.id_pogodbe) 
from m_pogodbe a where
a.datum_prekinitve is null and 
a.datum_zacetka<={?datum_do}-1 and a.datum_konca>={?datum_do}-1 and a.datum_konca-a.datum_zacetka>=364
?and a.objekt={?objekt}
)
where computer={?computer};

-- stevilo pogodb na zadnji izbrani dan obdobja, prekinjene pogodbe- short term
update report_sql set 
num9=(
select count (a.id_pogodbe) 
from m_pogodbe a where a.datum_prekinitve is not null and
a.datum_zacetka<={?datum_do}-1 and a.datum_prekinitve>={?datum_do}-1 and 
a.datum_prekinitve-a.datum_zacetka<=31
?and a.objekt={?objekt}
)
where computer={?computer};

-- stevilo pogodb na zadnji izbrani dan obdobja, prekinjene pogodbe- mid term
update report_sql set 
num16=(
select count (a.id_pogodbe) 
from m_pogodbe a where a.datum_prekinitve is not null and
a.datum_zacetka<={?datum_do}-1 and a.datum_prekinitve>={?datum_do}-1 and 
a.datum_prekinitve-a.datum_zacetka>31 and a.datum_prekinitve-a.datum_zacetka<364
?and a.objekt={?objekt}
)
where computer={?computer};


-- stevilo pogodb na zadnji izbrani dan obdobja, prekinjene pogodbe- long term
update report_sql set 
num10=(
select count (a.id_pogodbe) 
from m_pogodbe a where a.datum_prekinitve is not null and
a.datum_zacetka<={?datum_do}-1 and a.datum_prekinitve>={?datum_do}-1 and 
a.datum_prekinitve-a.datum_zacetka>=364
?and a.objekt={?objekt}
)
where computer={?computer};

-- delete from report_sql where num5=0 and num6=0 and computer={?computer};
