delete from report_sql where computer={?computer};

--dolzina (num1) in st. prostih privezov (num2)
insert into report_sql (computer, num1, num2, date1, date2)
select {?computer}, dolzina, count(*), {?datum_od}, {?datum_do} from nnprivez
where 1=1
?and objekt = {?objekt} 
?and kategorija = {?kategorija}
group by dolzina;

-- zasedeni privezi (num3)
update report_sql set
num3=nvl((select st_zased_dni_sum/({?datum_do}-{?datum_od}) from
          (select sum(st_zased_dni) as st_zased_dni_sum, dolzina from (
             select 
                 case when r.datum_od = r.datum_do then 1
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina
             from rezervac_detail r
             join nnprivez on r.id_privez=nnprivez.id_privez
             where r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
             ?and objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};



--noitve na voljo (num4)
update report_sql set
num4=({?datum_do}-{?datum_od})*num2
where computer={?computer};

--noitve zasedene (num5)
update report_sql set
num5=nvl((select st_zased_dni_sum from
          (select sum(st_zased_dni) as st_zased_dni_sum, dolzina from (
             select 
                 case when r.datum_od = r.datum_do then 1 
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina
             from rezervac_detail r
             join nnprivez on r.id_privez=nnprivez.id_privez
             where r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
             ?and objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};

--% zasedenih noi (num6)
update report_sql set
num6=(num5/num4)*100
where computer={?computer};


--metri na voljo (num7)
update report_sql set
num7=(num1*num2*({?datum_do}-{?datum_od}))
where computer={?computer};

--metri zasedeni (num8)
update report_sql set
num8=nvl((select zased_m from
          (select sum(st_zased_dni*dolzina_pl) as zased_m, dolzina from (
             select 
                 case when r.datum_od = r.datum_do then 1
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina,
                 plovila.dolzina as dolzina_pl
             from rezervac_detail r
             join nnprivez on r.id_privez=nnprivez.id_privez
             join rezervac on r.id_rezervac=rezervac.id
             join plovila  on rezervac.id_plovila=plovila.id
             where r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
             ?and objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};

--% zasedenih metrov (num9)
update report_sql set
num9 = 0
where computer={?computer};

update report_sql set
num9 = num8/num7*100
where computer={?computer}
and num7 <> 0;

--noitve na voljo za celo leto(num10)
update report_sql set
num10=({?datum_do}-TRUNC({?datum_od},'YEAR'))*num2
where computer={?computer};

--noitve zasedene za celo leto (num11)
update report_sql set
num11=nvl((select st_zased_dni_sum from
          (select sum(st_zased_dni) as st_zased_dni_sum, dolzina from (
             select 
                 case when r.datum_od = r.datum_do then 1 
                 when r.datum_od < TRUNC({?datum_od},'YEAR') then 
                     case when r.datum_do < {?datum_do} then r.datum_do - TRUNC({?datum_od},'YEAR')
                                                        else {?datum_do} - TRUNC({?datum_od},'YEAR')
                     end
                 when r.datum_od >= TRUNC({?datum_od},'YEAR') then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina
             from rezervac_detail r
             join nnprivez on r.id_privez=nnprivez.id_privez
             where r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > TRUNC({?datum_od},'YEAR') or
                  r.datum_od = r.datum_do and r.datum_od = TRUNC({?datum_od},'YEAR'))
             ?and objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};


--privezi zasedeni za annual contracts(num9) - 1.varianta - aktualni na zadnji dan obdobja
update report_sql set 
num9=(
select count (a.id_pogodbe) 
from m_vzorci_ps a, m_pogodbe b, plovila c where 
b.id_plovila=c.id and a.id_pogodbe=b.id_pogodbe and
(a.storitev ='BAR' or (a.storitev  ='ANU' and a.timekat='1') or a.storitev in ('POL','KBRO','KCAM'))
and b.datum_zacetka<={?datum_do} and b.datum_konca>={?datum_do}
?and c.pogodbeni_objekt_priveza={?objekt}
)
where computer={?computer};


--metri zasedeni za annual contracts(num18) - 1.varianta - aktualni na zadnji dan obdobja
update report_sql set 
num18=(
select sum (c.dolzina) 
from m_vzorci_ps a, m_pogodbe b, plovila c where 
b.id_plovila=c.id and a.id_pogodbe=b.id_pogodbe and
(a.storitev ='BAR' or (a.storitev  ='ANU' and a.timekat='1') or a.storitev in ('POL','KBRO','KCAM'))
and b.datum_zacetka<={?datum_do} and b.datum_konca>={?datum_do}
?and c.pogodbeni_objekt_priveza={?objekt} 
)
where computer={?computer};


--metri zasedeni za all contracts(num14) - 2.varianta - glede na datume pogodbe v obdobju in ne iz rezervacij
update report_sql set
num14=nvl((select zased_m from
          (select sum(st_zased_dni*dolzina_pl) as zased_m, dolzina from (
             select 
                 case when r.datum_zacetka = r.datum_konca then 1
                 when r.datum_zacetka < {?datum_od} then 
                     case when r.datum_konca < {?datum_do} then r.datum_konca - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_zacetka >= {?datum_od} then
                     case when r.datum_konca < {?datum_do} then r.datum_konca - r.datum_zacetka
                                                        else {?datum_do} - r.datum_zacetka 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina,
                 plovila.dolzina as dolzina_pl
             from m_pogodbe r
	     join m_vzorci_ps on r.id_pogodbe=m_vzorci_ps.id_pogodbe
             join nnprivez on r.n_priveza=nnprivez.n_priveza
             join plovila  on r.id_plovila=plovila.id
	     where
             (r.datum_zacetka < {?datum_do} and r.datum_konca > {?datum_od} or
                  r.datum_zacetka = r.datum_konca and r.datum_zacetka = {?datum_od})
             and m_vzorci_ps.storitev in ('ANCH', 'ANU', 'BAR', 'KBRO', 'KCAM', 'MON', 'POL', 'POLM', 'TRA', 'WEEK')
	     and m_vzorci_ps.storno is null
             ?and r.objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};


--metri zasedeni za annual contracts(num15) -2.varianta - glede na datume pogodbe v obdobju in ne iz rezervacij
update report_sql set
num15=nvl((select zased_m from
          (select sum(st_zased_dni*dolzina_pl) as zased_m, dolzina from (
             select 
                 case when r.datum_zacetka = r.datum_konca then 1
                 when r.datum_zacetka < {?datum_od} then 
                     case when r.datum_konca < {?datum_do} then r.datum_konca - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_zacetka >= {?datum_od} then
                     case when r.datum_konca < {?datum_do} then r.datum_konca - r.datum_zacetka
                                                        else {?datum_do} - r.datum_zacetka 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina,
                 plovila.dolzina as dolzina_pl
             from m_pogodbe r
	     join m_vzorci_ps on r.id_pogodbe=m_vzorci_ps.id_pogodbe
             join nnprivez on r.n_priveza=nnprivez.n_priveza
             join plovila  on r.id_plovila=plovila.id
	     where
             (r.datum_zacetka < {?datum_do} and r.datum_konca > {?datum_od} or
                  r.datum_zacetka = r.datum_konca and r.datum_zacetka = {?datum_od})
	     and (m_vzorci_ps.storitev ='BAR' or (m_vzorci_ps.storitev  ='ANU' and m_vzorci_ps.timekat='1') 
		  or m_vzorci_ps.storitev in ('POL','KBRO','KCAM'))
	     and m_vzorci_ps.storno is null
             ?and r.objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};


--metri zasedeni za all contracts (num16) - 3. varianta - glede na polje id_pogodbe iz rezervacij
update report_sql set
num16=nvl((select zased_m from
          (select sum(st_zased_dni*dolzina_pl) as zased_m, dolzina from (
             select 
                 case when r.datum_od = r.datum_do then 1
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina,
                 plovila.dolzina as dolzina_pl
             from rezervac_detail r
             join nnprivez on r.id_privez=nnprivez.id_privez
             join rezervac on r.id_rezervac=rezervac.id
             join plovila  on rezervac.id_plovila=plovila.id
             join m_vzorci_ps on rezervac.id_pogodbe=m_vzorci_ps.id_pogodbe
             where r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
	     and rezervac.id_pogodbe is not null
	     and m_vzorci_ps.storitev in ('ANCH', 'ANU', 'BAR', 'KBRO', 'KCAM', 'MON', 'POL', 'POLM', 'TRA', 'WEEK')
	     and m_vzorci_ps.storno is null
             ?and objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};


--metri zasedeni za annual contracts (num17) - 3. varianta - glede na polje id_pogodbe iz rezervacij
update report_sql set
num17=nvl((select zased_m from
          (select sum(st_zased_dni*dolzina_pl) as zased_m, dolzina from (
             select 
                 case when r.datum_od = r.datum_do then 1
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina,
                 plovila.dolzina as dolzina_pl
             from rezervac_detail r
             join nnprivez on r.id_privez=nnprivez.id_privez
             join rezervac on r.id_rezervac=rezervac.id
             join plovila  on rezervac.id_plovila=plovila.id
             join m_vzorci_ps on rezervac.id_pogodbe=m_vzorci_ps.id_pogodbe
             where r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
	     and rezervac.id_pogodbe is not null
	     and (m_vzorci_ps.storitev ='BAR' or (m_vzorci_ps.storitev  ='ANU' and m_vzorci_ps.timekat='1') 
		  or m_vzorci_ps.storitev in ('POL','KBRO','KCAM'))
	     and m_vzorci_ps.storno is null
             ?and objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};


--zasedeni privezi za all contracts (num12) -2.varianta - glede na datume pogodbe v obdobju in ne iz rezervacij
update report_sql set
num12=nvl((select st_zased_dni_sum/({?datum_do}-{?datum_od}) from
          (select sum(st_zased_dni) as st_zased_dni_sum, dolzina from (
             select 
                 case when r.datum_zacetka = r.datum_konca then 1
                 when r.datum_zacetka < {?datum_od} then 
                     case when r.datum_konca < {?datum_do} then r.datum_konca - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_zacetka >= {?datum_od} then
                     case when r.datum_konca < {?datum_do} then r.datum_konca - r.datum_zacetka
                                                        else {?datum_do} - r.datum_zacetka 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina
             from m_pogodbe r
             join nnprivez on r.n_priveza=nnprivez.n_priveza
             join m_vzorci_ps on r.id_pogodbe=m_vzorci_ps.id_pogodbe
             and (r.datum_zacetka < {?datum_do} and r.datum_konca > {?datum_od} or
                  r.datum_zacetka = r.datum_konca and r.datum_zacetka = {?datum_od})
	     and m_vzorci_ps.storitev in ('ANCH', 'ANU', 'BAR', 'KBRO', 'KCAM', 'MON', 'POL', 'POLM', 'TRA', 'WEEK')
	     and m_vzorci_ps.storno is null
             ?and r.objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};



-- zasedeni privezi za all contracts (num13) -3. varianta - glede na polje id_pogodbe iz rezervacij
update report_sql set
num13=nvl((select st_zased_dni_sum/({?datum_do}-{?datum_od}) from
          (select sum(st_zased_dni) as st_zased_dni_sum, dolzina from (
             select 
                 case when r.datum_od = r.datum_do then 1
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina
             from rezervac_detail r
             join nnprivez on r.id_privez=nnprivez.id_privez
             join rezervac on r.id_rezervac=rezervac.id
             join m_vzorci_ps on rezervac.id_pogodbe=m_vzorci_ps.id_pogodbe
             where r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
	     and rezervac.id_pogodbe is not null
	     and m_vzorci_ps.storitev in ('ANCH', 'ANU', 'BAR', 'KBRO', 'KCAM', 'MON', 'POL', 'POLM', 'TRA', 'WEEK')
	     and m_vzorci_ps.storno is null
             ?and objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};



--zasedeni privezi za annual contracts (num19) -2.varianta - glede na datume pogodbe v obdobju in ne iz rezervacij
update report_sql set
num19=nvl((select st_zased_dni_sum/({?datum_do}-{?datum_od}) from
          (select sum(st_zased_dni) as st_zased_dni_sum, dolzina from (
             select 
                 case 
                 when r.datum_zacetka = r.datum_konca then 1
                 when r.datum_zacetka < {?datum_od} then 
		      case when r.datum_konca < {?datum_do} then r.datum_konca - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
		      end		            
                 when r.datum_zacetka >= {?datum_od} then
                     case when r.datum_konca < {?datum_do} then r.datum_konca - r.datum_zacetka
                                                        else {?datum_do} - r.datum_zacetka 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina
             from m_pogodbe r
             join nnprivez on r.n_priveza=nnprivez.n_priveza
             join m_vzorci_ps on r.id_pogodbe=m_vzorci_ps.id_pogodbe
             and (r.datum_zacetka < {?datum_do} and r.datum_konca > {?datum_od} or
                  r.datum_zacetka = r.datum_konca and r.datum_zacetka = {?datum_od})
	     and (m_vzorci_ps.storitev ='BAR' or (m_vzorci_ps.storitev  ='ANU' and m_vzorci_ps.timekat='1') 
		  or m_vzorci_ps.storitev in ('POL','KBRO','KCAM'))
	     and m_vzorci_ps.storno is null
             ?and r.objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};



-- zasedeni privezi za annual contracts (num20) -3. varianta - glede na polje id_pogodbe iz rezervacij
update report_sql set
num20=nvl((select st_zased_dni_sum/({?datum_do}-{?datum_od}) from
          (select sum(st_zased_dni) as st_zased_dni_sum, dolzina from (
             select 
                 case 
                 when r.datum_od = r.datum_do then 1
                 when r.datum_od < {?datum_od} then 
                     case when r.datum_do < {?datum_do} then r.datum_do - {?datum_od}
                                                        else {?datum_do} - {?datum_od}
                     end
                 when r.datum_od >= {?datum_od} then
                     case when r.datum_do < {?datum_do} then r.datum_do - r.datum_od
                                                        else {?datum_do} - r.datum_od 
                     end
                 end as st_zased_dni, 
                 nnprivez.dolzina
             from rezervac_detail r
             join nnprivez on r.id_privez=nnprivez.id_privez
             join rezervac on r.id_rezervac=rezervac.id
             join m_vzorci_ps on rezervac.id_pogodbe=m_vzorci_ps.id_pogodbe
             where r.status_rezervac in (0,1) and complete is not null
             and (r.datum_od < {?datum_do} and r.datum_do > {?datum_od} or
                  r.datum_od = r.datum_do and r.datum_od = {?datum_od})
	     and rezervac.id_pogodbe is not null
	     and (m_vzorci_ps.storitev ='BAR' or (m_vzorci_ps.storitev  ='ANU' and m_vzorci_ps.timekat='1') 
		  or m_vzorci_ps.storitev in ('POL','KBRO','KCAM'))
	     and m_vzorci_ps.storno is null
             ?and objekt = {?objekt} 
             ?and kategorija = {?kategorija}
             )
            group by dolzina)
     where dolzina=num1),0)
where computer={?computer};