SELECT S.KUPCI_ID AS ID_LASTNIKA, 0 AS ID_PLOVILA, '' AS PLOVILO, ltrim(rtrim(S.KUPCI_PRIIMEK))||' '||ltrim(rtrim(S.KUPCI_IME)) as LASTNIK,
'' AS TRENUTNI_OBJEKT, '' AS POGODBENI_OBJEKT, (CASE WHEN Z.VALUTA_PLACILA = (SELECT DOMACAVALUTA FROM PARAM) THEN COALESCE(S.SALDAKONTI_SIT,0) ELSE COALESCE(S.SALDAKONTI_DEM,0) END) AS SALDO,
(COALESCE(S.COMMERCIAL_BALANCE,0)) AS SALDO_KOM,
(CASE WHEN Z.VALUTA_PLACILA = (SELECT DOMACAVALUTA FROM PARAM) THEN COALESCE(S.SALDAKONTI_SIT,0)+COALESCE(S.COMMERCIAL_BALANCE,0) ELSE COALESCE(S.SALDAKONTI_DEM,0)+COALESCE(S.COMMERCIAL_BALANCE,0) END) AS SKUPAJ
, (COALESCE(S.DEPOSIT,0)) AS DEPOSIT, COALESCE(S.OUTSTANDING_BALANCE, 0) AS OUTSTANDING_BALANCE
FROM V_KUPCI_BALANCE S JOIN KUPCI Z ON S.KUPCI_ID=Z.ID
WHERE S.NNFIRMA_ID IS NULL
AND
(COALESCE(S.SALDAKONTI_SIT,0)<>0
OR COALESCE(S.SALDAKONTI_DEM,0)<>0
OR COALESCE(S.COMMERCIAL_BALANCE,0)<>0
OR COALESCE(S.OUTSTANDING_BALANCE,0)<>0
) %FILTER%
ORDER BY (COALESCE(S.SALDAKONTI_SIT,0)+COALESCE(S.SALDAKONTI_DEM,0)+COALESCE(S.COMMERCIAL_BALANCE,0))
