delete from report_sql WHERE COMPUTER={?Computer};

insert into report_sql(computer,num1,date1,str1,num6,num2,num4,str2,num15)
select {?Computer},ID_KUPCA,DATUM,N_RACUNA,ID_SALDKONT,ZA_PLACILO, PROTIVREDNOST,'S',id_plovila
from SALDKONT
where SDK_RN_TIP = 'I' and SDK_RN_PL='R' 
?and datum>={?DatumOd} 
?and datum<={?DatumDo}
;

insert into report_sql(computer,num1,date1,str1,num6,num3,num5,str2,num15)
select {?Computer},ID_KUPCA,DATUM,N_RACUNA,ID_SALDKONT,ZA_PLACILO, PROTIVREDNOST,'S',id_plovila
from SALDKONT
where SDK_RN_TIP = 'I' and (SDK_RN_PL='P' or VRSTA_RACUNA='RAC') 
?and datum>={?DatumOd} 
?and datum<={?DatumDo}
;

insert into report_sql(computer,num1,date1,str1,num6,num7,num8,num9,num10,num11,num12,num13,num14,str2,num15)
select {?Computer}, a.id_lastnika, a.datum_dn, a.stevilka, a.id_dn, b.id_storitve,
b.znesek, b.davek, b.popust,b.popust1,b.popust2,b.provizija,b.tecajp,'P', a.id_plovila
from M_DE_NA a, M_STORITVE b
where a.ID_DN = b.ID_DN(+) and (b.N_RACUNA is null or (b.N_RACUNA is not null and b.N_RACUNA <> 'STORNO')) 
and a.STATUS = 'P' and a.CONFIRMED = 'Y' and b.vrsta='DN'
?and a.datum_dn>={?DatumOd} 
?and a.datum_dn<={?DatumDo}
;

insert into report_sql(computer,num1,date1,str1,num6,num7,num8,num9,num10,num11,num12,num13,num14,str2,num15)
select {?Computer}, a.id_lastnika, a.datum_dn, a.stevilka, a.id_dn, b.id_storitve,
b.znesek, b.davek, b.popust,b.popust1,b.popust2,b.provizija,b.tecajp,'R', a.id_plovila
from M_DE_NA a, M_STORITVE b
where a.ID_DN = b.ID_DN(+) and (b.N_RACUNA is null or (b.N_RACUNA is not null and b.N_RACUNA <> 'STORNO')) 
and a.STATUS = 'P' and a.CONFIRMED = 'Y' and b.vrsta='ST'
?and a.datum_dn>={?DatumOd} 
?and a.datum_dn<={?DatumDo}
;



